# Contributing to MangaDesk

🥳 Thank you for taking the time to contribute to this project!

This document lays out some general guidelines for contributing. Please take some time to read through it.

## Issues

Bug reports/fixes will always take priority over feature requests.

When opening a new issue, please include the following:

- Start your title with either a `[BUG]` or `[Feature Request]` tag so I know how to categorise your issue.
- For bug reports, include:
    - `Expected Behaviour`
    - `Actual Behaviour`
    - If possible, `Steps to Reproduce` the problem.
- If you feel any additional information would be helpful, such as screenshots, code snippets etc.., you may include it
  as well.

## Pull Requests

Always open an issue first before submitting a Pull Request. This way, there is opportunity for discussion before you
dedicate your time to writing code.

- Make sure that your code follows the current structure of the project. I may reject requests that do not follow this.
- Your code should be commented if possible. This way, I know exactly what is going on, and new contributors won't be
  lost.
- If your Pull Request fixes a bug, plese reference it in the comments so it is closed automatically.
- Consistency is key, and quality is a must.

### Thank you for contributing!
